<script lang="ts">

import Station from "@/components/dashboard/Station.vue"
import { defineComponent, reactive, ref } from "@vue/composition-api";
import { getConnection } from "@/plugins/connect"
import { StringCodec } from "nats.ws"
import { workstations, colors, Workstation, CodeRecord, EPNMessage, DDR, NonePayload } from "@/model"
import _ from "lodash";
import ChipCounter from "../ChipCounter.vue";

export default defineComponent({
	name: "Home",

	components: {
		Station,
		ChipCounter
	},
	setup() {
		const nc = getConnection();
		const sc = StringCodec();

		let dialog = ref(false);

		let form = reactive({
			rfid: "",
			orderid: "",
			passed: false,
			ordered: false,
			color: "",
			items: colors.map(x => ({ color: x, amount: 0 })),
			reason: "",
		} as any);

		let currentStation = ref<Workstation>(workstations.printer);
		let currentRecord = ref<CodeRecord>(workstations.printer.codetable[0]);
		// workstations.forEach(x => x.codetable.forEach(y => console.log(y.payloadType == NonePayload)));
		let recordProps = ref([] as string[]);
		let propData = {
			rfid: { label: "RFID", icon: "contactless" },
			orderid: { label: "OrderID", icon: "mdi-cart" },
			passed: { label: "Passed", icon: "mdi-check" },
			ordered: { label: "Ordered", icon: "mdi-check" },
			color: { label: "Color", icon: "mdi-format-color-fill" },
			items: { label: "Items", icon: "mdi-format-list-bulleted" },
			reason: { label: "Reason", icon: "" }
		}
		// let recordPropsSet = _.uniq(payloadTypes.flatMap(x => Object.getOwnPropertyNames(new x())));

		function openDialog(station: Workstation, { record }: { record: CodeRecord }) {
			currentStation.value = station;
			currentRecord.value = record;

			if (record.payloadType == NonePayload) {
				send();
				return;
			}

			var obj = new record.payloadType();
			recordProps.value = Object.getOwnPropertyNames(obj);
			dialog.value = true;
		}

		async function send() {
			let payload: any = {};
			for (var prop of recordProps.value) {
				payload[prop] = form[prop];
			}

			var msg: EPNMessage = { code: currentRecord.value.code, label: currentRecord.value.label };
			if (currentRecord.value.payloadType != NonePayload)
				msg.payload = payload;

			// console.log(payload);
			(await nc)?.publish(currentStation.value.label + (currentRecord.value.direction == DDR.FROM_SERVER ? ".job" : ".telemetry"), sc.encode(JSON.stringify(msg)));

			dialog.value = false;
		}

		return {
			workstations,
			colors,
			form,
			dialog,
			currentRecord,
			currentStation,
			recordProps,
			propData,
			openDialog,
			send
		}
	}
});
</script>


<template>
	<div>
		<v-dialog v-model="dialog" width="min-content">
			<v-form @submit.prevent="send()">
				<v-card class="payload-form">
					<v-card-title class="overline" style="fontSize: 20px">
						{{ currentRecord.code }} - {{ currentRecord.label }}
					</v-card-title>
					<v-card-text class="props">
						<div class="prop" v-for="prop in recordProps" :key="prop">
							<template v-if="prop == 'rfid'">
								<v-text-field hide-details solo dense
									:label="propData[prop].label"
									:prepend-icon="propData[prop].icon"
									v-model="form.rfid"></v-text-field>
							</template>
							<template v-if="prop == 'orderid'">
								<v-text-field hide-details solo dense
									:label="propData[prop].label"
									:prepend-icon="propData[prop].icon"
									v-model="form.orderid"></v-text-field>
							</template>
							<template v-if="prop == 'passed'">
								<v-checkbox class="mt-0 pt-0"
									hide-details
									solo
									:label="propData[prop].label"
									v-model="form.passed"></v-checkbox>
							</template>
							<template v-if="prop == 'ordered'">
								<v-checkbox class="mt-0 pt-0"
									hide-details
									:label="propData[prop].label"
									v-model="form.ordered"></v-checkbox>
							</template>
							<template v-if="prop == 'color'">
								<v-select
									:items="colors" solo hide-details dense
									:label="propData[prop].label"
									:prepend-icon="propData[prop].icon"
									v-model="form.color">
									<template v-slot:item="{item}">
										<chip-counter :color="item" left></chip-counter>
										{{ item }}
									</template>
								</v-select>
							</template>
							<template v-if="prop == 'reason'">
								<v-text-field hide-details solo dense
									:label="propData[prop].label"
									:prepend-icon="propData[prop].icon"
									v-model="form.reason"></v-text-field>
							</template>
							<template v-if="prop == 'items'">
								<div v-for="(color, i) in colors" :key="color" class="items-input">
									<chip-counter :color="color" size="2em"></chip-counter>
									<!-- <v-icon :color="color.toLowerCase()">contactless</v-icon>:  -->
									<v-text-field
										label="amount"
										type="number"
										hide-details
										solo
										value="0" min="0"
										v-model.number="form.items[i].amount"></v-text-field>
								</div>
							</template>
						</div>
					</v-card-text>
					<v-card-actions>
						<v-spacer></v-spacer>
						
						<v-btn text color="error" @click="dialog = false">
							Nevermind <v-icon right small>mdi-cancel</v-icon>
						</v-btn>
						<v-btn text color="success" @click="send()">
							Send <v-icon right small>mdi-send</v-icon>
						</v-btn>
					</v-card-actions>
				</v-card>
			</v-form>
		</v-dialog>
		<Station v-for="w in workstations" :key="w.label" :station="w" @send="openDialog(w, $event)"></Station>
	</div>
</template>

<style scoped>
.props {
	display: flex;
	flex-direction: column;
	row-gap: 20px;
}
.prop {
	display: flex;
	flex-direction: column;
	/* align-items: center; */
	/* justify-items: center; */
}
.overline {
	font-size: 0.8em !important;
}
.payload-form {
	width: 500px;
}
.items-input {
	display: flex;
	align-items: center;
	padding: 10px 0;
	column-gap: 5px;
}
.color-box {
	width: 10px;
	height: 10px;
}
</style>